- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::GenTMatrix Class Reference

Class for general matrices stored in triplet format. More...

`#include <IpGenTMatrix.hpp>`

Inheritance diagram for Ipopt::GenTMatrix:

[legend]
Collaboration diagram for Ipopt::GenTMatrix:

[legend]
List of all members.

## Public Member Functions
Constructors / Destructors
| GenTMatrix (const GenTMatrixSpace *owner_space)
| Constructor, taking the owner_space.
| ~GenTMatrix ()
| Destructor.
Changing the Values.
void | SetValues (const Number *Values)
| Set values of nonzero elements.
Accessor Methods
Index | Nonzeros () const
| Number of nonzero entries.
const Index * | Irows () const
| Array with Row indices (counting starts at 1).
const Index * | Jcols () const
| Array with Column indices (counting starts at 1).
const Number * | Values () const
| Array with nonzero values (const version).
Number * | Values ()
| Array with the nonzero values of this matrix (non-const version).
## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| GenTMatrix ()
| Default Constructor.
| GenTMatrix (const GenTMatrix &)
| Copy Constructor.
void | operator= (const GenTMatrix &)
| Overloaded Equals Operator.
## Private Attributes
const GenTMatrixSpace * | owner_space_
| Copy of the owner space as a GenTMatrixSpace instead of a MatrixSpace.
Number * | values_
| Values of nonzeros.
bool | initialized_
| Flag for Initialization.

## Detailed Description

Class for general matrices stored in triplet format.

In the triplet format, the nonzeros elements of a general matrix is stored in three arrays, Irow, Jcol, and Values, all of length Nonzeros. The first two arrays indicate the location of a non-zero element (row and column indices), and the last array stores the value at that location. If nonzero elements are listed more than once, their values are added.

The structure of the nonzeros (i.e. the arrays Irow and Jcol) cannot be changed after the matrix can been initialized. Only the values of the nonzero elements can be modified.

Note that the first row and column of a matrix has index 1, not 0.

Definition at line 36 of file IpGenTMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::GenTMatrix::GenTMatrix | ( | const GenTMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::GenTMatrix::~GenTMatrix | ( |  | ) |

Destructor.

Ipopt::GenTMatrix::GenTMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::GenTMatrix::GenTMatrix | ( | const GenTMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::GenTMatrix::SetValues | ( | const Number * | Values | ) |

Set values of nonzero elements.

The values of the nonzero elements is copied from the incoming Number array. Important: It is assume that the order of the values in Values corresponds to the one of Irn and Jcn given to one of the constructors above.

Index Ipopt::GenTMatrix::Nonzeros | ( |  | ) | const`[inline]`

Number of nonzero entries.

Definition at line 229 of file IpGenTMatrix.hpp.

References Ipopt::GenTMatrixSpace::Nonzeros(), and owner_space_.

const Index * Ipopt::GenTMatrix::Irows | ( |  | ) | const`[inline]`

Array with Row indices (counting starts at 1).

Definition at line 235 of file IpGenTMatrix.hpp.

References Ipopt::GenTMatrixSpace::Irows(), and owner_space_.

const Index * Ipopt::GenTMatrix::Jcols | ( |  | ) | const`[inline]`

Array with Column indices (counting starts at 1).

Definition at line 241 of file IpGenTMatrix.hpp.

References Ipopt::GenTMatrixSpace::Jcols(), and owner_space_.

const Number* Ipopt::GenTMatrix::Values | ( |  | ) | const`[inline]`

Array with nonzero values (const version).

Definition at line 73 of file IpGenTMatrix.hpp.

References values_.

Number* Ipopt::GenTMatrix::Values | ( |  | ) | `[inline]`

Array with the nonzero values of this matrix (non-const version).

Use this method only if you are intending to change the values, because the GenTMatrix will be marked as changed.

Definition at line 82 of file IpGenTMatrix.hpp.

References initialized_, Ipopt::TaggedObject::ObjectChanged(), and values_.

virtual void Ipopt::GenTMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::GenTMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::GenTMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::GenTMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::GenTMatrix::operator= | ( | const GenTMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

## Member Data Documentation

const GenTMatrixSpace* Ipopt::GenTMatrix::owner_space_`[private]`

Copy of the owner space as a GenTMatrixSpace instead of a MatrixSpace.

Reimplemented from Ipopt::Matrix.

Definition at line 134 of file IpGenTMatrix.hpp.

Referenced by Irows(), Jcols(), and Nonzeros().

Number* Ipopt::GenTMatrix::values_`[private]`

Values of nonzeros.

Definition at line 137 of file IpGenTMatrix.hpp.

Referenced by Values().

bool Ipopt::GenTMatrix::initialized_`[private]`

Flag for Initialization.

Definition at line 140 of file IpGenTMatrix.hpp.

Referenced by Values().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/LinAlg/TMatrices/IpGenTMatrix.hpp